//spark eroder ver 1.0
//fuses L:E4  H:C9

//spark eroder ver 1.0

#define F_CPU 8000000UL		// INIZIALIZZAZIONE CLOCK CPU
#include <stdlib.h>		// INCLUDO LE LIBRERIE
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include "uart.h"

//STORED IN FLASH
const uint8_t current[4] PROGMEM= {1,2,3,4};		// CORRENTE IMPOSTATA DA SCRIVERE SUL DISPLAY
const uint8_t resolution[4] PROGMEM= {64,32,16,8};	// RISOLUZIONE DEL MOTORE IMPOSTATA DA SCRIVERE SUL DISPLAY
const uint16_t conv_fact[4] PROGMEM= {1,2,4,8};		// SERVE PER FARE LA CONVERSIONE A RISPETTO LA RISOLUZIONE
const uint8_t item_pos_y[5] PROGMEM= {2,15,27,39,51};	// SERVE PER SCRIVERE SUL DISPLAY IL CURSORE CORDINATE Y
const uint8_t item_pos_x[5] PROGMEM= {87,87,87,87,87};	// SERVE PER SCRIVERE SUL DISPLAY IL CURSORE CORDINATE Y
//VARIABILI GLOBALI
static uint8_t FLAGS=0;
static uint8_t conversion_resol=0;
static uint16_t conversion_micron=0;
static uint32_t step=0;
static uint16_t micron=0;
static uint8_t sec=0;
static uint8_t min=0;
static uint16_t eoj=50;
static uint8_t incr1=0;
static uint8_t incr_jog=0;
static uint8_t time=0;
static uint8_t jog=0;
static uint8_t Resel=0;
static uint8_t PUMP=0;
static uint8_t Speed=0;
static uint8_t up=0;
static uint8_t down=0;
static uint16_t relative=0;
static uint16_t micron_R=1;
static uint16_t start=0;
static uint8_t interlock=0;
static uint8_t sing_step=0;
static uint8_t manual=0;
static uint8_t top=0;
///////////////////// COMANDO LED DISPLAY
static uint8_t led_h=0;
static uint8_t led_l=0;
//FLAGS
#define Pol		0
#define Pump		1
#define Edit		2
#define HV		3
#define Job		4
#define spark		5

#define fattore		1033/10
// E' stato scritto 1033/10 perchè così risparmio molta memoria invece che scrivere 103.1

#define UART_BAUD_RATE	19200	// DEFINISCO IL BAUD RATE DEL DISPLAY

// FUNZIONI PER MODIFICARE I SETTAGGI DEI FLAG
#define CLEAR_FLAG(y)		FLAGS&=~_BV(y)
#define SET_FLAG(y)		FLAGS|=_BV(y)
#define TOGGLE_FLAG(y)		FLAGS^=_BV(y)
#define FLAG_IS_SET(y)		(FLAGS & _BV(y))
#define FLAG_IS_CLEAR(y)	(~FLAGS & _BV(y))

// FUNZIONI PER MODIFICARE I SETTAGGI DELLE SINGOLE PORTE DELLA CPU
#define CLEAR_BIT(x,y)		x&=~_BV(y)
#define SET_BIT(x,y)		x|=_BV(y)
#define TOGGLE_BIT(x,y)		x^=_BV(y)
#define SET_BIT_AS_IN(x,y)	x&=~_BV(y)
#define SET_BIT_AS_OUT(x,y)	x|=_BV(y)
#define SET_PORT_AS_IN(x)	x=0x00
#define SET_PORT_AS_OUT(x)	x=0xff

//PORTB - OUT
#define HV_on 		0
#define PWM_out 	1
#define PUMP_on 	2
#define POL_tip 	3
#define Isel0 		4
#define Isel1 		5
#define Res0 		6
#define Res1		7
//PORTC-IN
#define Open_sig 	0
#define Short_sig 	1
#define Fc_dwn	 	2
#define Fc_up	 	3
//PORTD - IN/OUT
//PDO Rx
//PD1 Tx
#define Intrlk_mon	2
#define HV_mon		3
#define Enc_A		4
#define Enc_B		5
#define Clk		6
#define Dir		7

void uart_putn(uint8_t num){		// USATO PER SCRIVERE NUMERI A UNA CIFRA

  char buffer[10];
  utoa( num, buffer, 10);
  uart_puts(buffer);

}

void uart_put_nn(uint16_t num){		// USATO PER SCRIVERE NUMERI A DUE CIFRE

  char buffer[10];
  utoa( num, buffer, 10);

  if(num<10){
    uart_puts("0");
    uart_puts(buffer);
  }else{
    uart_puts(buffer);
  }

}

void uart_put_nnnn(uint16_t num){ 	// USATO PER SCRIVERE NUMERI A QUATTRO CIFRE

  char buffer[10];
  utoa( num, buffer, 10);

  if(num<10){
    uart_puts("000");
    uart_puts(buffer);
  }else if((num>=10)&&(num<100)){
    uart_puts("00");
    uart_puts(buffer);
  }else if((num>=100)&&(num<1000)){
    uart_puts("0");
    uart_puts(buffer);
  }else if((num>=1000)&&(num<10000))
    uart_puts(buffer);
  else
    uart_puts("9999");
}

void clear_screen(void){ 		// PULISCE LO SCHERMO
  uart_putc(254);
  uart_putc(88);
}

void cursor_position(int x, int y){ 	// POSIZIONA CARATTERI
  uart_putc(254);
  uart_putc(121);
  uart_putc(x);
  uart_putc(y);
}

void line_draw(int x1, int y1, int x2, int y2){ // SCRIVE LA RIGA NEL MEZZO
  uart_putc(254);
  uart_putc(108);
  uart_putc(x1);
  uart_putc(y1);
  uart_putc(x2);
  uart_putc(y2);
}

/**
________________________
| COLOUR | GP02 | GP01 |
| YELLOW |   0  |   0  |
|  GREEN |   0  |   1  |
|   RED  |   1  |   0  |
|   OFF  |   1  |   1  |
————————————————————————
________________________
| COLOUR | GP04 | GP03 |
| YELLOW |   0  |   0  |
|  GREEN |   0  |   1  |
|   RED  |   1  |   0  |
|   OFF  |   1  |   1  |
————————————————————————
________________________
| COLOUR | GP06 | GP05 |
| YELLOW |   0  |   0  |
|  GREEN |   0  |   1  |
|   RED  |   1  |   0  |
|   OFF  |   1  |   1  |
————————————————————————
*/

void GPO_ON(int num){ 			// METTE A ON IL NUM INSERITO CHE VIENE USATO PER
  uart_putc(254);			// COMANDARE I LED AL LATO DEL DISPLAY
  uart_putc(87);
  uart_putc(num);
}

void GPO_OFF(int num){			// METTE A OFF IL NUM INSERITO CHE VIENE USATO PER
  uart_putc(254);			// COMANDARE I LED AL LATO DEL DISPLAY
  uart_putc(86);
  uart_putc(num);
}

void current_set(uint8_t Isel){ // SCELTA DELLA CORRENTE DI LAVORO

/**
________________________
|  mA  | Isel1 | Isel0 |
|  14  |   0   |   0   |
|  19  |   0   |   1   |
|  31  |   1   |   0   |
|  78  |   1   |   1   |
————————————————————————
*/
  switch(Isel){
     case 3: CLEAR_BIT(PORTB,Isel0);CLEAR_BIT(PORTB,Isel1); break;
     case 2: CLEAR_BIT(PORTB,Isel0);SET_BIT(PORTB,Isel1); break;
     case 1: SET_BIT(PORTB,Isel0);CLEAR_BIT(PORTB,Isel1); break;
     case 0: SET_BIT(PORTB,Isel0);SET_BIT(PORTB,Isel1); break;
  }

}

void resolution_set(uint8_t Resel){ // SCELTA DELLA RISOLUZIONE DI LAVORO

/**
________________________
|  step  | Res1 | Res0 |
|  1/8   |   0  |   0  |
|  1/16  |   0  |   1  |
|  1/32  |   1  |   0  |
|  1/64  |   1  |   1  |
————————————————————————
*/
  switch(Resel){
     case 3: CLEAR_BIT(PORTB,Res0);CLEAR_BIT(PORTB,Res1); break;
     case 2: CLEAR_BIT(PORTB,Res0);SET_BIT(PORTB,Res1); break;
     case 1: SET_BIT(PORTB,Res0);CLEAR_BIT(PORTB,Res1); break;
     case 0: SET_BIT(PORTB,Res0);SET_BIT(PORTB,Res1); break;
  }

}

void init_display(void){ // MENU

  clear_screen();

  cursor_position(0,2);
  uart_puts("HV(300V):");

//_delay_ms(10);

  cursor_position(0,15);
  uart_puts("Iset :");

//_delay_ms(10);

  cursor_position(0,27);
  uart_puts("Tip Pol:");

//_delay_ms(10);

  cursor_position(0,39);
  uart_puts("Pump St:");

//_delay_ms(10);

  cursor_position(0,51);
  uart_puts("EoJ(um):");

//_delay_ms(10);

  line_draw(93,0,93,64);

//_delay_ms(10);

  cursor_position(100,2);
  uart_puts("Comm :");

_delay_ms(10);

  cursor_position(100,15);
  uart_puts("Z.A(um):");

_delay_ms(10);

  cursor_position(100,27);
  uart_puts("Z.R(um):");

_delay_ms(10);

  cursor_position(100,39);
  uart_puts("Time:");

_delay_ms(10);

  cursor_position(100,51);
  uart_puts(":");

}


void message(uint8_t n){ // MESSAGGIO DI LAVORO

	_delay_ms(10);
	cursor_position(105,51);

	switch(n){
		case 0:
			uart_puts("");
		break;

		case 1:
			uart_puts("Wait please");
		break;

		case 2:
			uart_puts("Intrlk FAIL");
		break;

		case 3:
			uart_puts("Working....");
		break;

		case 4:
			uart_puts("Job is done");
		break;

		case 5:
			uart_puts("           ");
		break;
	}
}


void draw_cursor(uint8_t off){ 			// SCRIVE IL CURSORE
  cursor_position(pgm_read_byte_near(item_pos_x+off),pgm_read_byte_near(item_pos_y+off));
  uart_puts("<");
}

void clear_cursor(uint8_t off){ 		// CANCELLA IL CURSORE
  cursor_position(pgm_read_byte_near(item_pos_x+off),pgm_read_byte_near(item_pos_y+off));
  uart_putc(32);
}


void refresh_I_NRG(uint8_t Isel){ 		// SCELTA LA CORRENTE

  cursor_position(65,15);
  uart_putn(pgm_read_byte_near(current+Isel));
  current_set(Isel);
}

void refresh_Command(void){ 			// SCELTA MODALITA' LAVORO

  cursor_position(142,2);
  _delay_ms(10);
  if(sing_step==0)
	uart_puts(" AUTO ");
  else
	uart_puts("MANUAL");

}

void refresh_HV(void){

  cursor_position(65,2);
  if(FLAG_IS_SET(HV)){
    GPO_ON(4);			// LED ROSSO
    GPO_OFF(3);
    uart_puts("ON ");
    SET_BIT(PORTB,HV_on); 	// HV ATTIVATA
  }else{
    GPO_ON(3);			// LED SPENTO
    GPO_ON(4);
    uart_puts("OFF");
    CLEAR_BIT(PORTB,HV_on); 	// HV DISATTIVATA
  }
}

void refresh_POL(void){		// SCELTA POLARITA'

  cursor_position(60,27);
  if(FLAG_IS_SET(Pol)){
    uart_puts("POS");
    CLEAR_BIT(PORTB,POL_tip); 	// POLARITA' POSITIVA
  }else{
    uart_puts("NEG");
    SET_BIT(PORTB,POL_tip); 	// POLARITA' NEGATIVA
  }
}

void refresh_PUMP(uint8_t PUMP){ // SCELTA DELLA CORRENTE DI LAVORO

cursor_position(60,39);
  switch(PUMP){
     case 0: OCR1B = 256; uart_puts("OFF"); break;
     case 1: OCR1B = 220; uart_puts(" 0 "); break;
     case 2: OCR1B = 200; uart_puts(" 1 "); break;
     case 3: OCR1B = 180; uart_puts(" 2 "); break;
     case 4: OCR1B = 160; uart_puts(" 3 "); break;
     case 5: OCR1B = 140; uart_puts(" 4 "); break;
     case 6: OCR1B = 120; uart_puts(" 5 "); break;
     case 7: OCR1B = 100; uart_puts(" 6 "); break;
     case 8: OCR1B = 80; uart_puts(" 7 "); break;
     case 9: OCR1B = 60; uart_puts(" 8 "); break;
     case 10: OCR1B = 40; uart_puts(" 9 "); break;
  }

}

/*
void refresh_PUMP(void){	// SCELTA POMPA

  cursor_position(60,39);
  if(FLAG_IS_SET(Pump)){
    uart_puts(" 1 ");
    SET_BIT(PORTB,PUMP_on); 	// POMPA ATTIVATA
  }else{
    uart_puts("OFF");
    CLEAR_BIT(PORTB,PUMP_on); 	// POMPA DISATTIVATA
  }

}
*/

void refresh_EOJ(void){ 	// SCRIVE QUANTO DEVE LAVORARE DALLO ZERO RELATIVO

  cursor_position(60,51);
  uart_put_nnnn(eoj);
}

void refresh_TIME(void){ 	// SCRIVE IL TEMPO DI LAVORO
  cursor_position(135,39);
  uart_put_nn(min);
  uart_puts(":");
  uart_put_nn(sec);
}

void refresh_Z_ass(void){ 	// SCRIVE LA Z ASSOLUTA

  cursor_position(156,15);
  uart_put_nnnn(micron);
  _delay_ms(10);

}

void refresh_Z_rel(void){ 	// SCRIVE LA Z RELATIVA

  cursor_position(156,27);
  uart_put_nnnn(micron_R);
  _delay_ms(10);

}

void timer0_init(void){ 	// DICHIARAZIONE DEL INTERRUPT 0
				// 32 msec, 1024 prescaler
  TCNT0=0;
  TIMSK0|=(1<<TOIE0);
  TCCR0B|=(1<<CS00)|(1<<CS02);
}

void timer1_init(void){ 	// DICHIARAZIONE DEL INTERRUPT 1
				// 1 sec circa, 256 prescaler
  TIMSK1|=(1<<OCIE1A);		// compare interrupt enable.
//  TCCR1B|=(1<<WGM12)|(1<<CS12)|(0<<CS11)|(0<<CS10); // CTC mode: top is OCR1A
  TCCR1B|=(1<<CS12)|(0<<CS11)|(0<<CS10); // CTC mode: top is OCR1A
  OCR1A = 31250; 		//1s
  TCNT1 = 0;


    DDRB |= (1 << DDB2);
    // PB2 is now an output

    ICR1 = 256;
    // set TOP to 8bit

    OCR1B = 250;
    // set PWM for 75% duty cycle @ 16bit

    TCCR1A |= (1 << COM1A1)|(1 << COM1B1);
    // set none-inverting mode

    TCCR1A |= (1 << WGM11)|(0 << WGM10);
    TCCR1B |= (1 << WGM12)|(1 << WGM13);
    // set Fast PWM mode using ICR1 as TOP
    
    //TCCR1B |= (1 << CS10);
    // START the timer with no prescaler

}

void timer2_init(void){		// DICHIARAZIONE DEL INTERRUPT 2
				// 400 usec circa, 64 prescaler
  TIMSK2|=(1<<OCIE2A);		// compare iterrupt enable.
  TCCR2A|=(1<<WGM21);
  TCCR2B|=(1<<CS22)|(0<<CS21)|(0<<CS20); // CTC mode: top is OCR2A
  OCR2A = 50; 			// 50 usec. se ci fosse un prescaler 8
  TCNT2 = 0;
}

//TOGGLE_BIT(PORTB,2);

ISR(TIMER2_COMPA_vect){		// SCRIVO NEL TIMER 2 COSA DEVE FARE
//CLEAR_BIT(PORTB,6);
//Resel=3;
		Speed = Resel;
		conversion_resol=pgm_read_byte_near(resolution+Speed);	// GUARDO A CHE RISOLUZIONE E' IMPOSTATO - NON IN USO
		conversion_micron=pgm_read_word_near(conv_fact+Speed);	// GUARDO A QUANTI MICRON ASSOLUTI SONO

//////////////////////////////////////////////// --- DOWN --- ////////////////////////////////////////////////

	if(down==1 && bit_is_clear(PINC,Fc_dwn) && sing_step==0 && top==0){
		CLEAR_BIT(PORTD,Dir);			// DIREZIONE DOVE DEVE ANDARE LA PUNTA
		_delay_us(100);
		SET_BIT(PORTD,Clk);			// SETTA IL CLOCK
		_delay_us(100);
		CLEAR_BIT(PORTD,Clk);			// RESETTA IL CLOCK

		step+=conversion_micron;		// CONTA QUANTI STEP HA FATTO E CONSIDERA QUANTI
							// NE AVEVA GIA' FATTI
		led_l=1; // VERDE			// ACCENDE IL LED BASSO DEL DISPLAY

	}else if(bit_is_set(PINC,Fc_dwn)){		// SE TOCCA IL FINE CORSA INFERIORE
		down=0;					// BLOCCA IL MOTORE E NON LO FA SCENDERE
		led_l=2; // ROSSO			// ACCENDE IL LED BASSO DEL DISPLAY
	}else if(bit_is_clear(PINC,Fc_dwn) && down==0)	// SE E' FERMO E NON E' SUL FINE CORSA
		led_l=0; // SPENTO			// SPENGE IL LED BASSO DEL DISPLAY

///////////////////////////////////////////////// --- UP --- /////////////////////////////////////////////////

	if(up==1 && bit_is_clear(PINC,Fc_up) && sing_step==0){
		if(top==1 && bit_is_clear(PIND,Enc_B))	// SE VIENE PIGIATO IL TASTO PER FARLO TORNARE SU
			top=0;				// AUTOMATICAMENTE BLOCCA LA SALITA SOLTANTO QUANDO
							// ARRIVA SUL FINE CORSA
		else{
			SET_BIT(PORTD,Dir);		// DIREZIONE DOVE DEVE ANDARE LA PUNTA
			_delay_us(100);
			SET_BIT(PORTD,Clk);		// SETTA IL CLOCK
			_delay_us(100);
			CLEAR_BIT(PORTD,Clk);		// RESETTA IL CLOCK

			step-=conversion_micron;	// CONTA QUANTI STEP HA FATTO E CONSIDERA QUANTI
							// NE AVEVA GIA' FATTI

			led_h=1; // VERDE		// ACCENDE IL LED BASSO DEL DISPLAY
		}

	}else if (bit_is_set(PINC,Fc_up)){		// SE TOCCA IL FINE CORSA SUPERIORE
		top=0;	 // blocca la salita auto
		up=0;					// BLOCCA IL MOTORE E NON LO FA SCENDERE
		step=0;					// AZZERA IL CONTATORE PER LA Z ASSOLUTA
		led_h=2; // ROSSO			// ACCENDE IL LED ALTO DEL DISPLAY
	}else if(bit_is_clear(PINC,Fc_up) && up==0)	// SE E' FERMO E NON E' SUL FINE CORSA
		led_h=0; // SPENTO			// SPENGE IL LED ALTO DEL DISPLAY

////////////////////////////   INIZIO JOG   ////////////////////////////

	if(bit_is_set(PIND,Enc_B) && bit_is_set(PIND,Enc_A) && top==0){	// SE NON E' PREMUNTO IL TASTO DI UP E DOWN
									// E NON STA SALENDO AUTOMATICAMENTE
		if((FLAG_IS_CLEAR(Job) && FLAG_IS_CLEAR(HV)) || (FLAG_IS_SET(HV)&&sing_step==1)){
			up=0;
			down=0;
			if(sing_step==0){		// SE NON E' IMPOSTATO SU MANUALE (sing_step)
				Resel=0;
				jog=0;
			}
		}
	}

	if(time==1 && incr_jog==0 && Resel<3){ 		// OGNI SECONDO
							// SE PREMI IL TASTO UP O DOWN
		if(bit_is_clear(PIND,Enc_B) || bit_is_clear(PIND,Enc_A)){
			jog=1;				// FA IL JOG E AUMENTA LA VELOCITA'
			Resel++;
		}
		incr_jog++;
	}
////////////////////////////    FINE JOG    ////////////////////////////
}
				// SCRIVO NEL TIMER 1 COSA DEVE FARE
ISR(TIMER1_COMPA_vect){ 	// AUMENTA LA VARIABILE CHE USERO' COME TEMPORIZZAZIONE AL SECONDO

TOGGLE_BIT(PORTB,2);
	time++;
	if(time==2){
		time=0;
	}
	incr1=0; 		// SE NON CI FOSSE INCREMENTEREBBE A BOMBA I SEC
	incr_jog=0;		// SE NON CI FOSSE INCREMENTEREBBE A BOMBA IL JOG
}

uint8_t incr2=0;
uint8_t Z_prof=0;
uint8_t int_timer0 = 0;
				// SCRIVO NEL TIMER 0 COSA DEVE FARE
ISR(TIMER0_OVF_vect){		// AGGIORNA LA Z QUANDO SCINTILLA

	int_timer0++;

	if(int_timer0>=31){
		//TOGGLE_BIT(PORTB,2);
		time++;
		if(time==2){
			time=0;
		}
		incr1=0; 		// SE NON CI FOSSE INCREMENTEREBBE A BOMBA I SEC
		incr_jog=0;		// SE NON CI FOSSE INCREMENTEREBBE A BOMBA IL JOG
		int_timer0=0;
	}

	resolution_set(Resel);  // SETTA LA RISOLUZIONE

	Z_prof++;
	if(Z_prof==7)
		Z_prof=0;
	incr2=0; 		// SE NON CI FOSSE INCREMENTEREBBE A BOMBA LA Z
}


int main(void){

  unsigned char c;
  uint8_t Isel=0;
  uint8_t item=0;

  SET_PORT_AS_OUT(DDRB);	// SETTA TUTTE LE PORTE B COME USCITE
  SET_PORT_AS_IN(DDRC);		// SETTA TUTTE LE PORTE C COME INGRESSO
  SET_BIT_AS_IN(DDRD,2); 	// INTERLOCK
  SET_BIT_AS_IN(DDRD,3);	// HV MON
  SET_BIT_AS_IN(DDRD,4); 	// ENC-A
  SET_BIT_AS_IN(DDRD,5); 	// ENC-B
  SET_BIT_AS_OUT(DDRD,6);	// CLK
  SET_BIT_AS_OUT(DDRD,7);	// DIR

  SET_BIT(PORTD,4); 		// SETTO A 1 ENC-A
  SET_BIT(PORTD,5); 		// SETTO A 1 ENC-B

//  SET_BIT(PORTC,0); 		// OPEN_SIG
//  SET_BIT(PORTC,1); 		// SHORT_SIG
  SET_BIT(PORTC,2); 		// FC_DWN
  SET_BIT(PORTC,3); 		// FC_UP

  CLEAR_BIT(PORTB,2);		// POMPA

  PORTB = 0x00;
  CLEAR_BIT(PORTD,Clk);
  CLEAR_BIT(PORTD,Dir);

  timer0_init();	// INIZIALIZZO TIMER 0
  timer1_init();	// INIZIALIZZO TIMER 0
  timer2_init();	// INIZIALIZZO TIMER 0
  uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU)); // INIZIALIZZA IL BAUD RATE PER IL DISPLAY
  sei(); 		// FA PARTIRE GLI INTERRUPT

  _delay_ms(1000);
  init_display(); 	// INIZIALIZZA IL DISPLAY
   _delay_ms(30);
  refresh_EOJ(); 	// AGGIORNA LA RIGA LAVORO SUL DISPLAY
  refresh_HV(); 	// AGGIORNA LA RIGA HV SUL DISPLAY
  refresh_Z_ass(); 	// AGGIORNA LA RIGA Z ASSOLUTA SUL DISPLAY
  _delay_ms(30);
  refresh_I_NRG(Isel); 	// AGGIORNA LA RIGA CORRENTE SUL DISPLAY
  refresh_POL(); 	// AGGIORNA LA RIGA POLARITA' SUL DISPLAY
  refresh_PUMP(PUMP); 	// AGGIORNA LA RIGA POMPA SUL DISPLAY
  _delay_ms(30);
  refresh_TIME(); 	// AGGIORNA LA RIGA TEMPO SUL DISPLAY
  refresh_Z_rel(); 	// AGGIORNA LA RIGA Z RELATIVA SUL DISPLAY
  _delay_ms(30);
  refresh_Command();	// AGGIORNA LA RIGA COMANDO SUL DISPLAY

  FLAGS=0;

  while(1){

////////////////////////    --- ACCENSIONA  LED DISPLAY ---    ////////////////////////

	if(led_h==0){		// LED SUPERIORE SPENTO (fermo)
	    	GPO_ON(1);
		GPO_ON(2);
	}else if(led_h==1){	// LED SUPERIORE VERDE (movimento)
		GPO_ON(1);
	    	GPO_OFF(2);
	}else{			// LED SUPERIORE ROSSO (fine corsa)
	    	GPO_OFF(1);
		GPO_ON(2);
	}

	if(led_l==0){		// LED INFERIORE SPENTO (fermo)
	    	GPO_ON(5);
		GPO_ON(6);
	}else if(led_l==1){	// LED INFERIORE VERDE (movimento)
		GPO_ON(5);
	    	GPO_OFF(6);
	}else{			// LED INFERIORE ROSSO (fine corsa)
	    	GPO_OFF(5);
		GPO_ON(6);
	}

/////////////////////////    --- AGGIORNAMENTO DISPLAY ---    /////////////////////////

	/////////////////    --- AGGIORNAMENTO   TEMPO ---    /////////////////

	if(FLAG_IS_SET(spark)){ 	 // SCRIVE SUL DISPLAY IL TEMPO
		if(time>=0 && incr1==0){ // DA QUANDO INIZIA A SCINTILLARE
			incr1++;
			sec++;
			if(sec==60){	// SE I SECONDI ARRIVANO A 60
				min++;	// INCREMENTA DI 1 I MINUTI
				sec=0;	// E AZZERA I SECONDI
			}
			refresh_TIME();	// AGGIORNA LA RIGA TEMPO SUL DISPLAY
		}			// MA SOLO MENTRE SCINTILLA
	}

	//////////////    --- AGGIORNAMENTO  PROFONDITA' ---    ///////////////

	if(Z_prof==6 && incr2==0){ 	// SCRIVE SUL DISPLAY LE PROFONDITA'
					// RELATIVE E ASSOLUTE

		micron=step/(fattore); 	// Ci vogliono le parentesi tra (fattore)

		if(relative==9999){	// SE HA FATTO LO ZERO RELATIVO
			down=0;		// OVVERO HA TROVATO LO SHORT
			relative=micron;
		}
		if (FLAG_IS_SET(spark) || sing_step==1){
			micron_R=micron-relative;
			if(micron_R > 6000)
				micron_R=0;
			refresh_Z_rel();	// AGGIORNA LA RIGA Z_RELATIVA SOLO SE
						// SCINTILLA O SE STO LAVORANDO IN MANUALE
		}
		refresh_Z_ass();		// AGGIORNA OGNI 200ms LA Z_ASS SUL DISPLAY
		incr2++;
	}

//////////////////////////////    --- SINGLE STEP ---    //////////////////////////////
	if(sing_step==1){			// SE E' IMPOSTATO SU LAVORAZIONE MANUALE
		if(down==1){
			CLEAR_BIT(PORTD,Dir);
			if(manual<=12){		// FA FARE 1um OGNI COLPO DI TASTO
				_delay_us(100);
				SET_BIT(PORTD,Clk);
				_delay_us(100);
				CLEAR_BIT(PORTD,Clk);

				step+=conversion_micron;
				manual++;
			}
		}

		if(up==1){
			SET_BIT(PORTD,Dir);

			if(manual<=12){		// FA FARE 1um OGNI COLPO DI TASTO

				_delay_us(100);
				SET_BIT(PORTD,Clk);
				_delay_us(100);
				CLEAR_BIT(PORTD,Clk);

				step-=conversion_micron;
				manual++;
			}
		}else if(up==0 && down==0 && sing_step==1)	// SERVE PER FAR RIPARTIRE
			manual=0;		// UP E DOWN DOPO 1um DI LAVORAZIONE MANUALE
	}

    c=uart_getc(); 				// PRENDE I COMANDI DA TASTIERINO

////////////////////////////    MENU ATTIVO CON CURSORE    ////////////////////////////

      if(FLAG_IS_SET(Edit)){

	  	_delay_us(50);
		draw_cursor(item); // DISEGNA IL CURSORE

	switch(c){

	case 0x45: 	// TASTO CENTRALE

	  micron=0;
	  sec=0;
	  min=0;

	  break;

	case 0x48: 	// FRECCIA GIU'

	  clear_cursor(item);

	  if(item<4) 		// SPOSTA IL CURSORE IN SU
	    item++;

	  draw_cursor(item); 	// DISEGNA IL CURSORE

	  break;

	case 0x42: 		// FRECCIA SU

	  clear_cursor(item);

	  if(item) 		// SPOSTA IL CURSORE IN GIU'
	    item--;

	  draw_cursor(item); 	// DISEGNA IL CURSORE

	  break;

	case 0x41: 		// TASTO ALTO SINISTRO

	  TOGGLE_FLAG(Edit); 	// ESCE DALLA MODALITA' CURSORE

	  clear_cursor(item); 	// TOGLIE IL CURSORE DAL MENU'

	  break;

	case 0x44: 	// FRECCIA SINISTRA

	  switch(item){		// MODALITA' EDITABILE NON EDITABILE

	  case 1:

	    if(FLAG_IS_CLEAR(HV)){

	      if(Isel) 		// DIMINUISCE LA CORRENTE
		Isel--;

	      refresh_I_NRG(Isel); // AGGIORNA LA RIGA CORRENTE SUL DISPLAY
	    }

	    break;

	  case 2:

	    if(FLAG_IS_CLEAR(HV)){

	      TOGGLE_FLAG(Pol);	// INVERTE LA POLARITA'

	      refresh_POL(); 	// AGGIORNA LA RIGA POLARITA' SUL DISPLAY
	    }

	    break;

	  case 3:

	    if(PUMP)
		PUMP--; 	// DIMINUISCE LA POMPA

	    refresh_PUMP(PUMP); 	// AGGIORNA LA RIGA POMPA SUL DISPLAY
	    break;

	  case 0:

	    TOGGLE_FLAG(HV); 	// INVERTE ON/OFF LA HV

	    refresh_HV(); 	// AGGIORNA LA RIGA HV SUL DISPLAY

	    break;

		 case 4:

		if(eoj) 	// DIMINUISCE QUANTO DEVE LAVORARE DALLA PRIMA SCINTILLA
	     eoj-=5;

	   refresh_EOJ(); 	// AGGIORNA LA RIGA DI LAVORO SUL DISPLAY

	    break;


	  }

	  break;

	case 0x43: 	// FRECCIA DESTRA

	  switch(item){

	  case 1:
	    if(FLAG_IS_CLEAR(HV)){

	      if(Isel<3) 	// AUMENTA LA CORRENTE
		Isel++;

	      refresh_I_NRG(Isel); // AGGIORNA LA RIGA CORRENTE SUL DISPLAY
	    }
	    break;

	  case 2:
	    if(FLAG_IS_CLEAR(HV)){

	      TOGGLE_FLAG(Pol);	// INVERTE LA POLARITA'

	      refresh_POL(); 	// AGGIORNA LA RIGA POLARITA' SUL DISPLAY
	    }
	    break;

	  case 3:

	    if(PUMP<10)
		PUMP++;		// INVERTE ON/OFF POMPA

	    refresh_PUMP(PUMP); 	// AGGIORNA LA RIGA POMPA SUL DISPLAY
	    break;

	  case 0:

	   TOGGLE_FLAG(HV); 	// INVERTE ON/OFF HV
	   refresh_HV(); 	// AGGIORNA LA RIGA HV SUL DISPLAY
	    break;

		 case 4:

		 if(eoj<9995) 	// AUMENTA QUANTO DEVE LAVORARE
			eoj+=5;

		refresh_EOJ(); 	// AGGIORNA LA RIGA DI LAVORO SUL DISPLAY

	    break;

	  }
	  break;

	}

      }else{

	  _delay_us(50);

////////////////////////////   MENU ATTIVO SENZA CURSORE   ////////////////////////////

	switch(c){

	case 0x42: 		// FRECCIA SU
	  if(FLAG_IS_CLEAR(Job)){
		sing_step=1;		// ATTIVA LA LAVORAZIONE MANUALE
		Resel=3;		// METTE LA MINIMA RISOLUZIONE
		refresh_Command();	// AGGIORNA LA RIGA COMANDO SUL DISPLAY
	  }

	break;

	case 0x48: 		// FRECCIA GIU'
	  if(FLAG_IS_CLEAR(Job)){
		sing_step=0;		// ATTIVA LA LAVORAZIONE AUTOMATICA
		Resel=0;		// METTE LA MASSIMA RISOLUZIONE
		refresh_Command();	// AGGIORNA LA RIGA COMANDO SUL DIPLAY
	  }

	break;
//////////////////   --- AUTO UP ---   //////////////////
	case 0x44:		// FRECCIA A SINISTRA
	    Resel=3;			// METTE LA MINIMA RISOLUZIONE
	    up=1;			// FA SALIRE L'UTENSILE
	    top=1;	  		// LO FA SALIRE FINE A CHE NON
					// TROVA IL FINE CORSA ALTO
	break;

	case 0x41: 		// TASTO ALTO A SINISTRA
	  if(FLAG_IS_CLEAR(Job)){
	    TOGGLE_FLAG(Edit); 		// ENTRA NELLA MODALITA' CURSORE
	  }
	break;

	case 0x47: 			// TASTO BASSO A SINISTRA
	  PUMP=0;	 		// SPEGNE LA POMPA
	  refresh_PUMP(PUMP); 		// AGGIORNA LA RIGA POMPA SUL DISPLAY
	break;

	case 0x45: 		// TASTO CENTRALE

	  if(FLAG_IS_CLEAR(Job)){	// INIZIA LA LAVORAZIONE
		  relative=0;		// AZZERA I MICRON RELATIVI
		  micron_R=0;
		  sec=0;		// IL TEMPO DI LAVORO
		  min=0;
		  _delay_ms(30);
		  refresh_Z_rel();	// AGGIORNA LA RIGA DELLA Z RELATIVA SUL DISPLAY
		  _delay_ms(30);
		  refresh_TIME();	// AGGIORNA LA RIGA DEL TEMPO SUL DISPLAY
	  }

	  CLEAR_FLAG(spark); 		// SPEGNE LA SCINTILLA
	  SET_FLAG(HV);   		// ATTIVA L'ALTA TENSIONE
	  TOGGLE_FLAG(Job);  		// ACCENTE/SPEGNE SE LAVORARE
	  sing_step=0;			// METTE IN MODALITA' LAVORO AUTOMATICA
	  start=0;			// FINCHE' E' start=0 FA SALIRE L'UTENSILE FINO A
	  _delay_ms(30);			// CHE NON TROVA IL FINE CORSA SUPERIORE
	  refresh_Command();		// AGGIORNA LA RIGA COMANDO SUL DIPLAY

	  if(FLAG_IS_SET(Job)){
		message(1); 		// ASPETTA L'HV
		refresh_HV();
		Resel=3;
		up=1;
	  }else{
		CLEAR_FLAG(HV);
	  	message(4); 		// LAVORO FINITO
		refresh_HV();
	  }

	  refresh_Z_ass();

	break;
	}
      }


////////////////////////////   MENTRE NON LAVORA   ////////////////////////////

	if(FLAG_IS_CLEAR(Job)&&FLAG_IS_CLEAR(HV)&&FLAG_IS_CLEAR(Edit)&&sing_step==0){
					// SE NON STA LAVORANDO L'HV NON E' ATTIVA NON
					// STAI EDITANDO IL MENU E LA LAVORAZIONE E'
					// AUTOMATICA

		if(bit_is_clear(PIND,Enc_B))		// ALLORA TI FA SALIRE SE
			up=1;				// PREMI IL TASTO UP

		else if(bit_is_clear(PIND,Enc_A))	// TI FA SCENDERE SE PREMI
			down=1;				// IL TASTO DOWN

	}else if(sing_step==1){		// SE HAI IMPOSTATO LA LAVORAZIONE MANUALE
					// ALLORA FUNZIONA UP/DOWN ANCHE SE L'HV
					// O IL JOB SONO ATTIVI
		if(bit_is_clear(PIND,Enc_B))
			up=1;

		else if(bit_is_clear(PIND,Enc_A))
			down=1;
	}

	if(bit_is_clear(PIND,Intrlk_mon)){ // SE LO SWITCH INTERLOCK E' APERTO
		CLEAR_FLAG(Job); 	   // SMETTE DI LAVORARE, STACCA HV
		CLEAR_FLAG(HV);
		CLEAR_FLAG(spark);	   // E SMETTE DI SCINTILLARE
		_delay_ms(30);
		refresh_HV();
		message(2); 		   // TI SCRIVE CHE HAI APERTO L'INTERLOCK
		interlock=0;
	}else if (interlock==0){
		_delay_ms(30);
		message(5);		   // CANCELLA OGNI SCRITTA PRECENDETE SE NON LAVORA
		interlock++;
	}
////////////////////////////     MENTRE LAVORA     ////////////////////////////

    if(FLAG_IS_SET(Job)&&FLAG_IS_SET(HV)&&start==1){

      //Open(PINC 0)/Short(PINC 1)
      //00 = spark -> tool stop - none
      //01 = short -> tool up
      //10 = open -> tool down
      //11 = none

	if(FLAG_IS_SET(spark)){		// SE HA GIA' INIZIATO A LAVORARE APPLICA UN RITARDO
		down=0;			// PER VIA DEL RC CHE C'E' ALL'INGRESSO DEI COMPARATORI
		up=0;			// E BLOCCA LA LAVORAZIONE
		_delay_ms(30);
	}else if(FLAG_IS_CLEAR(spark)){
		_delay_ms(1);
	}

	if(relative==0){		// SE ANCORA NON HA FATTO LO ZERO RELATIVO

		if(bit_is_clear(PINC,Open_sig)){	// SE SUPERA LA CONDIZIONE DI OPEN

			_delay_us(300);

			if(Resel!=0){
				down=0;
				up=1;
			}else{
				up=0;
				down=1;
				if(bit_is_set(PINC,Short_sig) && Resel==0){
					down=0;
					relative=9999;	// PERMETTE DI FAR AZZERARE LA Z_RELATIVA
					_delay_ms(3000);// E INIZIARE LA LAVORAZIONE
				}
			}
		}else{

			_delay_us(300);

			if(up==1){
				_delay_ms(500);
				Resel=0;
			}
			up=0;
			down=1;
		}
	}else{			// INIZIO DELLA LAVORAZIONE CON ZERO RELATIVO GIA' FATTO
		if(bit_is_clear(PINC,Open_sig)){ 			// SE ANCORA NON HA TOCCATO

			_delay_us(200);

			if(bit_is_clear(PINC,Short_sig) && FLAG_IS_CLEAR(spark)){
									// SE NON C'E' IL CORTO E
									// E NON SCINTILLA
				down=0;
				micron=0;
				SET_FLAG(spark); 			// INIZIA A SCINTILLARE
				message(3); 	 			// STA LAVORANDO

			}else if(bit_is_clear(PINC,Short_sig)){
				down=0;
				up=0;

				GPO_ON(3);				// LED CENTRALE VERDE
				GPO_OFF(4);				// SIGNIFICA CHE SCARICA
		 	}else{
				down=0;
				up=1;
		 	}
		}else{
		  up=0;
		  down=1;
		  GPO_ON(4);			// LED CENTRALE ROSSO
		  GPO_OFF(3);			// SIGNIFICA CHE C'E' L'HV
		}
	}

	if(FLAG_IS_SET(spark)&&(micron_R>eoj)){ // SE SCINTILLA E IL VALORE IMPOSTATO
					      	// E' UGUALE ALLA Z (VALORE LETTO)
		CLEAR_FLAG(spark); 		// SMETTE DI SCINTILLARE
	   	TOGGLE_FLAG(Job); 		// SMETTE DI LAVORARE
		TOGGLE_FLAG(HV); 		// STACCA HV
		refresh_HV(); 			// SCRIVE OFF SULLA RIGA HV DEL DISPLAY
		_delay_ms(1000);
		message(4);			// LAVORO ESEGUITO
	}
      }else if(FLAG_IS_SET(Job)&&FLAG_IS_SET(HV)&&start==0){	// SE ANCORA NON HA FATTO LO
								// ZERO RELATIVO E NON HA TROVATO
								// IL FINE CORSA SUPERIORE
	up=1;
	  if(bit_is_set(PINC,Fc_up)){		// SALE FINO A CHE NON TROVA IL FINE CORSA SUPERIORE
	    up=0;
	    start=1;
	  }
      }

    }  // CHIUSURA WHILE
  return 0;
} // CHIUSURA MAIN ()
